// Undo_Redo_DemoDoc.h : interface of the CUndo_Redo_DemoDoc class
// As part of the Undo_Redo_Demo application
// By Tom Morris of trilobiteWorks. December 2002
// Use freely...
#pragma once
#include "UpdateMgr.h"
#include "DocVars.h"

class CUndo_Redo_DemoDoc : public CDocument
{
protected: // create from serialization only
	CUndo_Redo_DemoDoc();
	DECLARE_DYNCREATE(CUndo_Redo_DemoDoc)

// Attributes
public:

private:
	BOOL		m_bUndosAreAvailable;
	BOOL		m_bRedosAreAvailable;

	CDocVars	m_CurrentDocVars;	//	Main holder of current DocVars values
	CUpdateMgr	m_UpdateMgr;		//	DocVars server

// Operations
public:

	void		DocVarsUpdate(CDocVars DocVars);
	void		DocVarsUndo();
	void		DocVarsRedo();
	CDocVars	DocVarsGetByValue();
	CDocVars	*DocVarsGetPointer();
	CDocVars	DocVarsCreateUniqueCopy(CDocVars theseDocVars);

	void		SetUndoAvailability(BOOL bAvail);
	void		SetRedoAvailability(BOOL bAvail);
	BOOL		WeHaveUndosLeft();
	BOOL		WeHaveRedosLeft();

// Overrides
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);

// Implementation
public:
	virtual ~CUndo_Redo_DemoDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	DECLARE_MESSAGE_MAP()
};


